"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unsafeGet = exports.prune = exports.merge = exports.make = exports.isTag = exports.isContext = exports.getOption = exports.get = exports.empty = exports.add = exports.Tag = void 0;
var C = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/data/internal/Context"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const TagTypeId = C.TagTypeId;
/**
 * Specifying the key will make the Tag global, meaning two tags with the same
 * key will map to the same instance.
 *
 * Note: this is useful for cases where live reload can happen and it is
 * desireable to preserve the instance across reloads.
 *
 * @since 1.0.0
 * @category constructors
 */
const Tag = key => new C.TagImpl(key);
exports.Tag = Tag;
const TypeId = C.ContextTypeId;
/**
 * @since 1.0.0
 * @category guards
 */
const isContext = C.isContext;
/**
 * @since 1.0.0
 * @category guards
 */
exports.isContext = isContext;
const isTag = C.isTag;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.isTag = isTag;
const empty = C.empty;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.empty = empty;
const make = C.make;
/**
 * @since 1.0.0
 * @category mutations
 */
exports.make = make;
const add = C.add;
/**
 * @since 1.0.0
 * @category getters
 */
exports.add = add;
const get = C.get;
/**
 * @since 1.0.0
 * @category unsafe
 */
exports.get = get;
const unsafeGet = C.unsafeGet;
/**
 * @since 1.0.0
 * @category getters
 */
exports.unsafeGet = unsafeGet;
const getOption = C.getOption;
/**
 * @since 1.0.0
 * @category mutations
 */
exports.getOption = getOption;
const merge = C.merge;
/**
 * @since 1.0.0
 * @category mutations
 */
exports.merge = merge;
const prune = C.prune;
exports.prune = prune;
//# sourceMappingURL=Context.js.map