declare const TypeId: unique symbol;
/**
 * @since 1.0.0
 * @category symbol
 */
export type TypeId = typeof TypeId;
/**
 * @since 1.0.0
 * @category models
 */
export interface Duration {
    readonly _id: TypeId;
    readonly millis: number;
}
/**
 * @since 1.0.0
 * @category guards
 */
export declare const isDuration: (u: unknown) => u is Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const zero: Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const infinity: Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const millis: (millis: number) => Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const seconds: (seconds: number) => Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const minutes: (minutes: number) => Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const hours: (hours: number) => Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const days: (days: number) => Duration;
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const weeks: (weeks: number) => Duration;
/**
 * @since 1.0.0
 * @category mutations
 */
export declare const times: {
    (self: Duration, times: number): Duration;
    (times: number): (self: Duration) => Duration;
};
/**
 * @since 1.0.0
 * @category mutations
 */
export declare const add: {
    (self: Duration, that: Duration): Duration;
    (that: Duration): (self: Duration) => Duration;
};
/**
 * @since 1.0.0
 * @category mutations
 */
export declare const subtract: {
    (self: Duration, that: Duration): Duration;
    (that: Duration): (self: Duration) => Duration;
};
/**
 * @since 1.0.0
 * @category comparisons
 */
export declare const lessThan: {
    (self: Duration, that: Duration): boolean;
    (that: Duration): (self: Duration) => boolean;
};
/**
 * @since 1.0.0
 * @category comparisons
 */
export declare const lessThanOrEqualTo: {
    (self: Duration, that: Duration): boolean;
    (that: Duration): (self: Duration) => boolean;
};
/**
 * @since 1.0.0
 * @category comparisons
 */
export declare const greaterThan: {
    (self: Duration, that: Duration): boolean;
    (that: Duration): (self: Duration) => boolean;
};
/**
 * @since 1.0.0
 * @category comparisons
 */
export declare const greaterThanOrEqualTo: {
    (self: Duration, that: Duration): boolean;
    (that: Duration): (self: Duration) => boolean;
};
/**
 * @since 1.0.0
 * @category comparisons
 */
export declare const equals: {
    (self: Duration, that: Duration): boolean;
    (that: Duration): (self: Duration) => boolean;
};
export {};
//# sourceMappingURL=Duration.d.ts.map