"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zero = exports.weeks = exports.times = exports.subtract = exports.seconds = exports.minutes = exports.millis = exports.lessThanOrEqualTo = exports.lessThan = exports.isDuration = exports.infinity = exports.hours = exports.greaterThanOrEqualTo = exports.greaterThan = exports.equals = exports.days = exports.add = void 0;
var Dual = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/data/Dual"));
var Equal = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/data/Equal"));
var Hash = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/data/Hash"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * @since 1.0.0
 */

const TypeId = /*#__PURE__*/Symbol.for("@fp-ts/data/Duration");
/** @internal */
class DurationImpl {
  constructor(millis) {
    this.millis = millis;
    this._id = TypeId;
  }
  [Hash.symbol]() {
    return Hash.hash(this.millis);
  }
  [Equal.symbol](that) {
    return isDuration(that) && this.millis === that.millis;
  }
}
/**
 * @since 1.0.0
 * @category guards
 */
const isDuration = u => typeof u === "object" && u != null && "_id" in u && u["_id"] === TypeId;
/**
 * @since 1.0.0
 * @category constructors
 */
exports.isDuration = isDuration;
const zero = /*#__PURE__*/new DurationImpl(0);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.zero = zero;
const infinity = /*#__PURE__*/new DurationImpl(Infinity);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.infinity = infinity;
const millis = millis => new DurationImpl(millis);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.millis = millis;
const seconds = seconds => new DurationImpl(seconds * 1000);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.seconds = seconds;
const minutes = minutes => new DurationImpl(minutes * 60000);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.minutes = minutes;
const hours = hours => new DurationImpl(hours * 3600000);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.hours = hours;
const days = days => new DurationImpl(days * 86400000);
/**
 * @since 1.0.0
 * @category constructors
 */
exports.days = days;
const weeks = weeks => new DurationImpl(weeks * 604800000);
/**
 * @since 1.0.0
 * @category mutations
 */
exports.weeks = weeks;
const times = /*#__PURE__*/Dual.dual(2, (self, times) => new DurationImpl(self.millis * times));
/**
 * @since 1.0.0
 * @category mutations
 */
exports.times = times;
const add = /*#__PURE__*/Dual.dual(2, (self, that) => new DurationImpl(self.millis + that.millis));
/**
 * @since 1.0.0
 * @category mutations
 */
exports.add = add;
const subtract = /*#__PURE__*/Dual.dual(2, (self, that) => new DurationImpl(self.millis - that.millis));
/**
 * @since 1.0.0
 * @category comparisons
 */
exports.subtract = subtract;
const lessThan = /*#__PURE__*/Dual.dual(2, (self, that) => self.millis < that.millis);
/**
 * @since 1.0.0
 * @category comparisons
 */
exports.lessThan = lessThan;
const lessThanOrEqualTo = /*#__PURE__*/Dual.dual(2, (self, that) => self.millis <= that.millis);
/**
 * @since 1.0.0
 * @category comparisons
 */
exports.lessThanOrEqualTo = lessThanOrEqualTo;
const greaterThan = /*#__PURE__*/Dual.dual(2, (self, that) => self.millis > that.millis);
/**
 * @since 1.0.0
 * @category comparisons
 */
exports.greaterThan = greaterThan;
const greaterThanOrEqualTo = /*#__PURE__*/Dual.dual(2, (self, that) => self.millis >= that.millis);
/**
 * @since 1.0.0
 * @category comparisons
 */
exports.greaterThanOrEqualTo = greaterThanOrEqualTo;
const equals = /*#__PURE__*/Dual.dual(2, (self, that) => self.millis === that.millis);
exports.equals = equals;
//# sourceMappingURL=Duration.js.map