"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.singleShot = exports.makeGenKind = exports.adapter = exports.These = exports.SingleShotGen = exports.Option = exports.GenKindTypeId = exports.GenKindImpl = exports.Either = void 0;
var E = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/core/Either"));
var _Function = /*#__PURE__*/require("@fp-ts/core/Function");
var O = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/core/Option"));
var T = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@fp-ts/core/These"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _a;
/**
 * @since 1.0.0
 */

/**
 * @category symbols
 * @since 1.0.0
 */
const GenKindTypeId = /*#__PURE__*/Symbol.for("@fp-ts/data/Gen/GenKind");
/**
 * @category constructors
 * @since 1.0.0
 */
exports.GenKindTypeId = GenKindTypeId;
class GenKindImpl {
  constructor(
  /**
   * @since 1.0.0
   */
  value) {
    this.value = value;
    /**
     * @since 1.0.0
     */
    this[_a] = GenKindTypeId;
  }
  /**
   * @since 1.0.0
   */
  get _F() {
    return _Function.identity;
  }
  /**
   * @since 1.0.0
   */
  get _R() {
    return _ => _;
  }
  /**
   * @since 1.0.0
   */
  get _O() {
    return _ => _;
  }
  /**
   * @since 1.0.0
   */
  get _E() {
    return _ => _;
  }
  /**
   * @since 1.0.0
   */
  [(_a = GenKindTypeId, Symbol.iterator)]() {
    return new SingleShotGen(this);
  }
}
/**
 * @category constructors
 * @since 1.0.0
 */
exports.GenKindImpl = GenKindImpl;
class SingleShotGen {
  constructor(self) {
    this.self = self;
    this.called = false;
  }
  /**
   * @since 1.0.0
   */
  next(a) {
    return this.called ? {
      value: a,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 1.0.0
   */
  return(a) {
    return {
      value: a,
      done: true
    };
  }
  /**
   * @since 1.0.0
   */
  throw(e) {
    throw e;
  }
  /**
   * @since 1.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen(this.self);
  }
}
/**
 * @category constructors
 * @since 1.0.0
 */
exports.SingleShotGen = SingleShotGen;
const makeGenKind = kind => new GenKindImpl(kind);
/**
 * @category adapters
 * @since 1.0.0
 */
exports.makeGenKind = makeGenKind;
const adapter = () => kind => new GenKindImpl(kind);
exports.adapter = adapter;
function runGen(F, state, iterator) {
  if (state.done) {
    return F.of(state.value);
  }
  return F.flatMap(val => {
    const next = iterator.next(val);
    return runGen(F, next, iterator);
  })(state.value.value);
}
/**
 * @category constructors
 * @since 1.0.0
 */
const singleShot = F => adapter => body => (0, _Function.pipe)(F.of(void 0), F.flatMap(() => {
  const iterator = body(adapter);
  const state = iterator.next();
  // @ts-expect-error
  return runGen(F, state, iterator);
}));
/**
 * @since 1.0.0
 * @category instances
 */
exports.singleShot = singleShot;
const Either = /*#__PURE__*/singleShot(E.Monad)( /*#__PURE__*/adapter());
/**
 * @since 1.0.0
 * @category instances
 */
exports.Either = Either;
const These = /*#__PURE__*/singleShot(T.Monad)( /*#__PURE__*/adapter());
/**
 * @since 1.0.0
 * @category instances
 */
exports.These = These;
const Option = /*#__PURE__*/singleShot(O.Monad)( /*#__PURE__*/adapter());
exports.Option = Option;
//# sourceMappingURL=Gen.js.map