import type * as Order from "@fp-ts/core/typeclass/Order";
import * as Equal from "@fp-ts/data/Equal";
import * as Hash from "@fp-ts/data/Hash";
import { RedBlackTreeIterator } from "@fp-ts/data/internal/RedBlackTree/iterator";
import * as Node from "@fp-ts/data/internal/RedBlackTree/node";
import type * as RBT from "@fp-ts/data/RedBlackTree";
export declare class RedBlackTreeImpl<K, V> implements RBT.RedBlackTree<K, V> {
    readonly _ord: Order.Order<K>;
    readonly _root: Node.Node<K, V> | undefined;
    readonly _id: RBT.TypeId;
    constructor(_ord: Order.Order<K>, _root: Node.Node<K, V> | undefined);
    [Hash.symbol](): number;
    [Equal.symbol](that: unknown): boolean;
    [Symbol.iterator](): RedBlackTreeIterator<K, V>;
    toString(): string;
    toJSON(): {
        _tag: string;
        values: (readonly [K, V])[];
    };
}
//# sourceMappingURL=RedBlackTree.d.ts.map