import * as C from "@fp-ts/data/internal/Context";
const TagTypeId = C.TagTypeId;
/**
 * Specifying the key will make the Tag global, meaning two tags with the same
 * key will map to the same instance.
 *
 * Note: this is useful for cases where live reload can happen and it is
 * desireable to preserve the instance across reloads.
 *
 * @since 1.0.0
 * @category constructors
 */
export const Tag = key => new C.TagImpl(key);
const TypeId = C.ContextTypeId;
/**
 * @since 1.0.0
 * @category guards
 */
export const isContext = C.isContext;
/**
 * @since 1.0.0
 * @category guards
 */
export const isTag = C.isTag;
/**
 * @since 1.0.0
 * @category constructors
 */
export const empty = C.empty;
/**
 * @since 1.0.0
 * @category constructors
 */
export const make = C.make;
/**
 * @since 1.0.0
 * @category mutations
 */
export const add = C.add;
/**
 * @since 1.0.0
 * @category getters
 */
export const get = C.get;
/**
 * @since 1.0.0
 * @category unsafe
 */
export const unsafeGet = C.unsafeGet;
/**
 * @since 1.0.0
 * @category getters
 */
export const getOption = C.getOption;
/**
 * @since 1.0.0
 * @category mutations
 */
export const merge = C.merge;
/**
 * @since 1.0.0
 * @category mutations
 */
export const prune = C.prune;
//# sourceMappingURL=Context.mjs.map