/**
 * @since 1.0.0
 */
import * as OP from "@fp-ts/data/internal/Differ/OrPatch";
const TypeId = OP.OrPatchTypeId;
/**
 * Constructs an empty `OrPatch`.
 *
 * @since 1.0.0
 * @category constructors
 */
export const empty = OP.empty;
/**
 * Constructs an `OrPatch` from a new and old value and a differ for the
 * values.
 *
 * @since 1.0.0
 * @category constructors
 */
export const diff = OP.diff;
/**
 * Combines two or patches to produce a new or patch that describes applying
 * their changes sequentially.
 *
 * @since 1.0.0
 * @category mutations
 */
export const combine = OP.combine;
/**
 * Applies an `OrPatch` to a value to produce a new value which represents
 * the original value updated with the changes described by this patch.
 *
 * @since 1.0.0
 * @category destructors
 */
export const patch = OP.patch;
//# sourceMappingURL=OrPatch.mjs.map